unit FEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, TB97, StdCtrls, RichEdit;

type
  TFrmEdit = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Editor: TRichEdit;
    Dock971: TDock97;
    Toolbar971: TToolbar97;
    StatusBar: TStatusBar;
    ListMsg: TListBox;
    FindDialog1: TFindDialog;
    procedure ToolbarButton971Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure EditorSelectionChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Function CurrText: TTextAttributes;
  end;

var
  FrmEdit: TFrmEdit;

implementation

{$R *.DFM}

procedure TFrmEdit.ToolbarButton971Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TFrmEdit.FindDialog1Find(Sender: TObject);
var
  FoundAt: LongInt;
begin
  with Editor do
  begin
    FoundAt := Pos(FindDialog1.FindText, Text) - 1;

    if (FoundAt <> 0) then
    begin
      SetFocus;
      SelStart := FoundAt;
      SelLength := Length(FindDialog1.FindText);
    end;
  end;
end;

procedure TFrmEdit.EditorSelectionChange(Sender: TObject);
var
  CharPos: TPoint;
begin
  CharPos.Y := SendMessage(Editor.Handle, EM_EXLINEFROMCHAR, 0,
    Editor.SelStart);
  CharPos.X := (Editor.SelStart -
    SendMessage(Editor.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
  StatusBar.Panels[0].Text := Format('Line: %3d   Col: %3d', [CharPos.Y, CharPos.X]);
end;

Function TFrmEdit.CurrText: TTextAttributes;
begin
  If Editor.SelLength > 0 Then
    Result := Editor.SelAttributes
  Else
    Result := Editor.DefAttributes;
end;

procedure TFrmEdit.FormResize(Sender: TObject);
begin
  ListMsg.Width:=Self.Width-5;
end;

end.
